diff --git a/src/XSHA512_fmt_plug.c b/src/XSHA512_fmt_plug.c
index bafd50c61e..c1f9013079 100644
--- a/src/XSHA512_fmt_plug.c
+++ b/src/XSHA512_fmt_plug.c
@@ -157,13 +157,13 @@ static int get_hash_5(int index) { return crypt_out[index][0] & PH_MASK_5; }
 static int get_hash_6(int index) { return crypt_out[index][0] & PH_MASK_6; }
 #endif
 
-int binary_hash_0 (void *p) { return *((uint64_t*)p) & PH_MASK_0; }
-int binary_hash_1 (void *p) { return *((uint64_t*)p) & PH_MASK_1; }
-int binary_hash_2 (void *p) { return *((uint64_t*)p) & PH_MASK_2; }
-int binary_hash_3 (void *p) { return *((uint64_t*)p) & PH_MASK_3; }
-int binary_hash_4 (void *p) { return *((uint64_t*)p) & PH_MASK_4; }
-int binary_hash_5 (void *p) { return *((uint64_t*)p) & PH_MASK_5; }
-int binary_hash_6 (void *p) { return *((uint64_t*)p) & PH_MASK_6; }
+static int binary_hash_0 (void *p) { return *((uint64_t*)p) & PH_MASK_0; }
+static int binary_hash_1 (void *p) { return *((uint64_t*)p) & PH_MASK_1; }
+static int binary_hash_2 (void *p) { return *((uint64_t*)p) & PH_MASK_2; }
+static int binary_hash_3 (void *p) { return *((uint64_t*)p) & PH_MASK_3; }
+static int binary_hash_4 (void *p) { return *((uint64_t*)p) & PH_MASK_4; }
+static int binary_hash_5 (void *p) { return *((uint64_t*)p) & PH_MASK_5; }
+static int binary_hash_6 (void *p) { return *((uint64_t*)p) & PH_MASK_6; }
 
 static int salt_hash(void *salt)
 {
diff --git a/src/sl3_fmt_plug.c b/src/sl3_fmt_plug.c
index aa59d017a9..94e6fccb92 100644
--- a/src/sl3_fmt_plug.c
+++ b/src/sl3_fmt_plug.c
@@ -57,8 +57,12 @@ john_register_one(&fmt_sl3);
 #ifdef SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT  NBKEYS
 #define MAX_KEYS_PER_CRYPT  NBKEYS
+#if ARCH_LITTLE_ENDIAN==1
 #define GETPOS(i, index)    ( (index&(SIMD_COEF_32-1))*4 + ((i)&(0xffffffff-3))*SIMD_COEF_32 + (3-((i)&3)) + (unsigned int)index/SIMD_COEF_32*SHA_BUF_SIZ*4*SIMD_COEF_32 ) //for endianity conversion
 #else
+#define GETPOS(i, index)    ( (index&(SIMD_COEF_32-1))*4 + ((i)&(0xffffffff-3))*SIMD_COEF_32 + ((i)&3) + (unsigned int)index/SIMD_COEF_32*SHA_BUF_SIZ*4*SIMD_COEF_32 ) //for endianity conversion
+#endif
+#else
 #define MIN_KEYS_PER_CRYPT  1
 #define MAX_KEYS_PER_CRYPT  1
 #endif
@@ -118,7 +122,7 @@ static void *get_binary(char *ciphertext) {
 	memset(out, 0, BINARY_SIZE);
 	base64_convert(ciphertext, e_b64_hex, 2 * BINARY_SIZE,
 	               out, e_b64_raw, BINARY_SIZE, 0, 0);
-#ifdef SIMD_COEF_32
+#if defined(SIMD_COEF_32) && ARCH_LITTLE_ENDIAN==1
 	alter_endianity((unsigned char*)out, BINARY_SIZE);
 #endif
 	return (void*)out;
@@ -148,6 +152,7 @@ static void set_key(char *_key, int index)
 		*d++ = *_key++ - '0';
 	} while (i--);
 
+#if ARCH_LITTLE_ENDIAN==1
 	*keybuf_word = JOHNSWAP(*wkey++);
 	keybuf_word += SIMD_COEF_32;
 	*keybuf_word = JOHNSWAP(*wkey++);
@@ -155,6 +160,15 @@ static void set_key(char *_key, int index)
 	*keybuf_word = JOHNSWAP(*wkey++);
 	keybuf_word += SIMD_COEF_32;
 	*keybuf_word = JOHNSWAP(*wkey);
+#else
+	*keybuf_word = *wkey++;
+	keybuf_word += SIMD_COEF_32;
+	*keybuf_word = *wkey++;
+	keybuf_word += SIMD_COEF_32;
+	*keybuf_word = *wkey++;
+	keybuf_word += SIMD_COEF_32;
+	*keybuf_word = *wkey;
+#endif
 
 #else
 	char *d = saved_key[index];
diff --git a/src/ssha512_fmt_plug.c b/src/ssha512_fmt_plug.c
index f818c8b91f..3c2d0ffa64 100644
--- a/src/ssha512_fmt_plug.c
+++ b/src/ssha512_fmt_plug.c
@@ -75,7 +75,11 @@ struct s_salt
 static struct s_salt *saved_salt;
 
 #ifdef SIMD_COEF_64
+#if ARCH_LITTLE_ENDIAN==1
 #define GETPOS(i, index)        ( (index&(SIMD_COEF_64-1))*8 + ((i)&(0xffffffff-7))*SIMD_COEF_64 + (7-((i)&7)) + (unsigned int)index/SIMD_COEF_64*SHA_BUF_SIZ*SIMD_COEF_64*8 )
+#else
+#define GETPOS(i, index)        ( (index&(SIMD_COEF_64-1))*8 + ((i)&(0xffffffff-7))*SIMD_COEF_64 + ((i)&7) + (unsigned int)index/SIMD_COEF_64*SHA_BUF_SIZ*SIMD_COEF_64*8 )
+#endif
 static uint64_t (*saved_key)[SHA_BUF_SIZ*SIMD_COEF_64];
 static uint64_t (*crypt_out)[8*SIMD_COEF_64];
 static uint64_t (**len_ptr64);
@@ -149,6 +153,7 @@ static void set_key(char *key, int index) {
 	uint64_t temp;
 
 	len = 0;
+#if ARCH_LITTLE_ENDIAN==1
 	while((unsigned char)(temp = *wkey++)) {
 		if (!(temp & 0xff00))
 		{
@@ -193,6 +198,52 @@ static void set_key(char *key, int index) {
 			goto key_cleaning;
 		}
 		*keybuf_word = JOHNSWAP64(temp);
+#else
+	while((temp = *wkey++)  & 0xff00000000000000ULL) {
+		if (!(temp & 0xff000000000000ULL))
+		{
+			*keybuf_word = (temp & 0xff00000000000000ULL) | (0x80ULL << 48);
+			len++;
+			goto key_cleaning;
+		}
+		if (!(temp & 0xff0000000000ULL))
+		{
+			*keybuf_word = (temp & 0xffff000000000000ULL) | (0x80ULL << 40);
+			len+=2;
+			goto key_cleaning;
+		}
+		if (!(temp & 0xff00000000ULL))
+		{
+			*keybuf_word = (temp & 0xffffff0000000000ULL) | (0x80ULL << 32);
+			len+=3;
+			goto key_cleaning;
+		}
+		if (!(temp & 0xff000000))
+		{
+			*keybuf_word = (temp & 0xffffffff00000000ULL) | (0x80ULL << 24);
+			len+=4;
+			goto key_cleaning;
+		}
+		if (!(temp & 0xff0000))
+		{
+			*keybuf_word = (temp & 0xffffffffff000000ULL) | (0x80 << 16);
+			len+=5;
+			goto key_cleaning;
+		}
+		if (!(temp & 0xff00))
+		{
+			*keybuf_word = (temp & 0xffffffffffff0000ULL) | (0x80 << 8);
+			len+=6;
+			goto key_cleaning;
+		}
+		if (!(temp & 0xff))
+		{
+			*keybuf_word = temp | 0x80;
+			len+=7;
+			goto key_cleaning;
+		}
+		*keybuf_word = temp;
+#endif
 		len += 8;
 		keybuf_word += SIMD_COEF_64;
 	}
@@ -350,6 +401,14 @@ static int get_hash_5(int index) { return crypt_out[index][0] & PH_MASK_5; }
 static int get_hash_6(int index) { return crypt_out[index][0] & PH_MASK_6; }
 #endif
 
+static int binary_hash_0 (void *p) { return *((uint64_t*)p) & PH_MASK_0; }
+static int binary_hash_1 (void *p) { return *((uint64_t*)p) & PH_MASK_1; }
+static int binary_hash_2 (void *p) { return *((uint64_t*)p) & PH_MASK_2; }
+static int binary_hash_3 (void *p) { return *((uint64_t*)p) & PH_MASK_3; }
+static int binary_hash_4 (void *p) { return *((uint64_t*)p) & PH_MASK_4; }
+static int binary_hash_5 (void *p) { return *((uint64_t*)p) & PH_MASK_5; }
+static int binary_hash_6 (void *p) { return *((uint64_t*)p) & PH_MASK_6; }
+
 static int salt_hash(void *salt)
 {
 	struct s_salt * mysalt = salt;
@@ -387,13 +446,13 @@ struct fmt_main fmt_saltedsha2 = {
 		{ NULL },
 		fmt_default_source,
 		{
-			fmt_default_binary_hash_0,
-			fmt_default_binary_hash_1,
-			fmt_default_binary_hash_2,
-			fmt_default_binary_hash_3,
-			fmt_default_binary_hash_4,
-			fmt_default_binary_hash_5,
-			fmt_default_binary_hash_6
+			binary_hash_0,
+			binary_hash_1,
+			binary_hash_2,
+			binary_hash_3,
+			binary_hash_4,
+			binary_hash_5,
+			binary_hash_6
 		},
 		salt_hash,
 		NULL,
